using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;

namespace Com.Telecomscloud.Api.TelecomsCloud.Model
{

    /// <summary>
    /// Model for FaxOutboundGetUpdatesCollectionResponseModel
    /// </summary>
    [DataContract]
    public class FaxOutboundGetUpdatesCollectionResponseModel :  IEquatable<FaxOutboundGetUpdatesCollectionResponseModel>
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="FaxOutboundGetUpdatesCollectionResponseModel" /> class.
        /// </summary>
        public FaxOutboundGetUpdatesCollectionResponseModel()
        {
            
        }

        
        /// <summary>
        /// Gets or Sets Updates
        /// </summary>
        [DataMember(Name="updates", EmitDefaultValue=false)]
        public FaxOutboundGetUpdatesResponseModel Updates { get; set; }
  
        
  
        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class FaxOutboundGetUpdatesCollectionResponseModel {\n");
            sb.Append("  Updates: ").Append(Updates).Append("\n");
            
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="obj">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object obj)
        {
            // credit: http://stackoverflow.com/a/10454552/677735
            return this.Equals(obj as FaxOutboundGetUpdatesCollectionResponseModel);
        }

        /// <summary>
        /// Returns true if FaxOutboundGetUpdatesCollectionResponseModel instances are equal
        /// </summary>
        /// <param name="other">Instance of FaxOutboundGetUpdatesCollectionResponseModel to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(FaxOutboundGetUpdatesCollectionResponseModel other)
        {
            // credit: http://stackoverflow.com/a/10454552/677735
            if (other == null)
                return false;

            return 
                (
                    this.Updates == other.Updates ||
                    this.Updates != null &&
                    this.Updates.Equals(other.Updates)
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            // credit: http://stackoverflow.com/a/263416/677735
            unchecked // Overflow is fine, just wrap
            {
                int hash = 41;
                // Suitable nullity checks etc, of course :)
                
                if (this.Updates != null)
                    hash = hash * 59 + this.Updates.GetHashCode();
                
                return hash;
            }
        }

    }
}
